Name:          jedit
Version:       4.3.2
Release:       1mamba
Summary:       Programmer's Text Editor
Group:         Graphical Desktop/Applications/Development
Vendor:        openmamba
Distribution:  openmamba
Packager:      gil <puntogil@libero.it>
URL:           http://www.jedit.org/ 
Source0:       http://downloads.sourceforge.net/sourceforge/jedit/jedit%{version}source.tar.bz2
Source1:       jedit.desktop
Source2:       jedit-script
Patch0:        jedit-4.3-installer.patch
Patch1:        jedit-4.3-fop-dir.patch
License:       GPL
BuildRequires: apache-ant
BuildRequires: apache-ant-nodeps
BuildRequires: apache-batik = 1.7
BuildRequires: apache-fop = 0.95
BuildRequires: docbook-dtds
BuildRequires: docbook-xsl
BuildRequires: jakarta-commons-logging
BuildRequires: jakarta-commons-io = 1.4
BuildRequires: java-bsh2
BuildRequires: java-bsh2-classgen
BuildRequires: java-excalibur-avalon-framework
BuildRequires: java-saxon6-aelfred
BuildRequires: java-gnu-regexp
BuildRequires: libxslt
BuildRequires: objectweb-asm = 3.2
BuildRequires: rsync
BuildRequires: xerces-j2
BuildRequires: xml-commons
BuildRequires: xmlgraphics-commons = 1.3.1
Requires:      antlr = 2.7.7
Requires:      java-bsh2
Requires:      java-gnu-regexp
Requires:      java-saxon6-aelfred
Requires:      jpackage-utils
Requires:      objectweb-asm = 3.2
BuildRoot:     %{_tmppath}/%{name}-%{version}-root

%description
jEdit is a mature programmer's text editor with hundreds (counting the time
developing plugins) of person-years of development behind it.

Some of jEdit's features include:

* Written in Java, so it runs on Mac OS X, OS/2, Unix, VMS and Windows.
* Built-in macro language; extensible plugin architecture. Dozens of macros and plugins available.
* Plugins can be downloaded and installed from within jEdit using the "plugin manager" feature.
* Auto indent, and syntax highlighting for more than 130 languages.
* Supports a large number of character encodings including UTF8 and Unicode.
* Folding for selectively hiding regions of text.
* Word wrap.
* Highly configurable and customizable.
* Every other feature, both basic and advanced, you would expect to find in a text editor.
  See the Features page for a full list.

%package javadoc
Group:          Documentation
Summary:        Javadoc for %{name}

%description javadoc
jEdit is a mature programmer's text editor with hundreds (counting the time
developing plugins) of person-years of development behind it.

This package contains javadoc for %{name}.

%package manual
Group:          Documentation
Summary:        Manual for %{name}

%description manual
jEdit is a mature programmer's text editor with hundreds (counting the time
developing plugins) of person-years of development behind it.

This package contains documentation for %{name}.

%prep

%setup -q -c %{name}-%{version}
# -D -T
#:<< ___GIL
%patch0 -p0
%patch1 -p0

# todo edit /usr/share/sgml/docbook/xsl-stylesheets-1.76.1/fo/fop.xsl change http://xml.apache.org/fop/extensions with http://xmlgraphics.apache.org/fop/extensions

pushd jEdit
cat > build.properties << __GIL
build.dir=build
dist.dir=dist
docbook.xsl=`rpm -ql docbook-xsl | grep /html/chunk.xsl | sed 's|/html/chunk.xsl||'`
rsync.executable=%{_bindir}/rsync
xsltproc.executable=%{_bindir}/xsltproc
fop.dir=%{_javadir}
build.debug=true
build.debuglevel=lines,vars,source
__GIL
rm -rf bsh
rm -rf com
rm -rf gnu
rm -rf org/objectweb

popd

#___GIL
%build
#:<< ___GIL
pushd jEdit

JAVA_HOME=/usr/lib/jvm/jdk-sun
perl -p -i -e 's|compress="false"|compress="true"|' build.xml
perl -p -i -e 's|app.version=.*|app.version=%{version}-%{release}|' installer/install.props

PDF_DOC="fop fop-pdf-transcoder fop-hyph fop-sandbox fop-transcoder-allinone commons-logging commons-io xmlgraphics-commons excalibur/avalon-framework batik-svg-dom batik-dom batik-util batik-bridge batik-css"

export CLASSPATH=$(build-classpath bsh2/bsh-classgen bsh2/bsh-commands bsh2/bsh-core bsh2/bsh-reflect saxon-aelfred gnu-regexp \
	objectweb-asm/asm $PDF_DOC xercesImpl ant/ant-nodeps)
ant

mkdir -p dist/jars
export SGML_CATALOG_FILES=%{_sysconfdir}/sgml/catalog
ant docs-html dist

(cd jars/LatestVersion && ant)

(cd jars/QuickNotepad && ant)

ant -Dj2se.api=%{_javadocdir}/java docs-javadoc

popd
#___GIL
%install
[ "%{buildroot}" != / ] && rm -rf "%{buildroot}"
pushd jEdit

export JAVA_HOME=/usr/lib/jvm/jdk-sun
export CLASSPATH="."

java -cp dist/jedit%{version}install.jar installer.Install auto %{buildroot}%{_datadir}/jedit unix-man=%{buildroot}%{_mandir}/man1

(
	cd %{buildroot}%{_datadir}/jedit/doc
	rm -rf api
	ln -sf %{_javadocdir}/jedit api
)

#mkdir -p %{buildroot}%{_datadir}/jedit

mkdir -p  %{buildroot}%{_javadocdir}/jedit-%{version}
cp -pr build/doc/api/* %{buildroot}%{_javadocdir}/jedit-%{version}
ln -s jedit-%{version} %{buildroot}%{_javadocdir}/jedit

#rm -rf build/doc/api

#cp -pr build/{doc,macros,modes,properties,startup} %{buildroot}%{_datadir}/jedit

cp -pr build/doc/FAQ %{buildroot}%{_datadir}/jedit/doc
cp -pr build/doc/news43 %{buildroot}%{_datadir}/jedit/doc
cp -pr build/doc/tips %{buildroot}%{_datadir}/jedit/doc
cp -pr build/doc/users-guide %{buildroot}%{_datadir}/jedit/doc
cp -pr build/doc/*.png %{buildroot}%{_datadir}/jedit/doc
cp -pr build/doc/*.txt %{buildroot}%{_datadir}/jedit/doc
cp -pr build/doc/*.html %{buildroot}%{_datadir}/jedit/doc

# conflicts with file from package antlr 2.7.7
rm -rf %{buildroot}%{_datadir}/jedit/modes/antlr.xml

#mkdir -p %{buildroot}%{_mandir}/man1
#install -pm 644 package-files/linux/jedit.1 %{buildroot}%{_mandir}/man1

mkdir -p %{buildroot}%{_datadir}/applications
desktop-file-install %{SOURCE1} --mode=644 --dir=%{buildroot}%{_datadir}/applications %{buildroot}%{_datadir}/applications/jedit.desktop

mkdir -p %{buildroot}%{_bindir}
install -pm 755 %{SOURCE2} %{buildroot}%{_bindir}/jedit

for i in 16 22 24 32 48 64 72 96 ; do
	mkdir -p %{buildroot}%{_datadir}/icons/hicolor/${i}x${i}/apps
	convert -geometry ${i}x${i} doc/jedit.png %{buildroot}%{_datadir}/icons/hicolor/${i}x${i}/apps/jedit.png
done

mkdir -p %{buildroot}%{_datadir}/icons/hicolor/128x128/apps
install -pm 644 doc/jedit.png %{buildroot}%{_datadir}/icons/hicolor/128x128/apps/

mkdir -p %{buildroot}%{_datadir}/pixmaps
install -pm 644 icons/jedit-icon48.png %{buildroot}%{_datadir}/pixmaps/jedit.png

mkdir -p %{buildroot}%{_javadir}
install -m 644 build/jedit.jar \
	%{buildroot}%{_javadir}/jedit-%{version}.jar

rm -rf %{buildroot}%{_datadir}/jedit/jedit.jar

(
	cd %{buildroot}%{_javadir}
	for jar in *-%{version}*; do
		ln -sf ${jar} ${jar/-%{version}/}
	done
	ln -sf ../java/jedit-%{version}.jar %{buildroot}%{_datadir}/jedit/jedit.jar
)

mkdir -p %{buildroot}%{_datadir}/jedit/jars
cat > %{buildroot}%{_datadir}/jedit/jars/readme.txt << __GIL
default plugins directory
__GIL
popd

%clean
[ "%{buildroot}" != / ] && rm -rf "%{buildroot}"

%post
%{_bindir}/update-desktop-database -q %{_datadir}/applications
touch --no-create %{_datadir}/icons/hicolor

%postun
%{_bindir}/update-desktop-database -q %{_datadir}/applications
if [ $1 -eq 0 ]; then
	touch --no-create %{_datadir}/icons/hicolor
	%{_bindir}/gtk-update-icon-cache %{_datadir}/icons/hicolor &> /dev/null || :
fi

%posttrans
%{_bindir}/gtk-update-icon-cache %{_datadir}/icons/hicolor &> /dev/null || :

%files
%defattr(-,root,root)
%attr(0755,root,root) %{_bindir}/jedit
%{_javadir}/jedit-%{version}.jar
%{_javadir}/jedit.jar
%dir %{_datadir}/jedit
%{_datadir}/jedit/@LongLink
%{_datadir}/jedit/jedit.jar
%{_datadir}/jedit/doc
%exclude %{_datadir}/jedit/doc/api
%{_datadir}/jedit/macros
%{_datadir}/jedit/modes
%{_datadir}/jedit/properties
%{_datadir}/jedit/startup
%dir %{_datadir}/jedit/jars
%{_datadir}/jedit/jars/readme.txt
%{_datadir}/pixmaps/jedit.png
%{_datadir}/icons/hicolor/*x*/apps/jedit.png
%{_datadir}/applications/jedit.desktop
%{_mandir}/man1/jedit.1.gz

%files javadoc
%defattr(-,root,root)
%{_datadir}/jedit/doc/api
%{_javadocdir}/jedit-%{version}
%{_javadocdir}/jedit

%files manual
%defattr(-,root,root)
%doc jEdit/dist/*.pdf

%changelog
* Fri Jun 25 2010 gil <puntogil@libero.it> 4.3.2-1mamba
- update to 4.3.2

* Tue Mar 09 2010 gil <puntogil@libero.it> 4.3.1-1mamba
- update to 4.3.1

* Tue Jan 05 2010 gil <puntogil@libero.it> 4.3-2mamba
- added %{_datadir}/jedit/jars default plugins directory

* Tue Jan 05 2010 gil <puntogil@libero.it> 4.3-1mamba
- update to 4.3

* Thu Jul 23 2009 gil <puntogil@libero.it> 4.3pre17-2mamba
- rebuilt with system java-bsh2

* Tue Jul 14 2009 gil <puntogil@libero.it> 4.3pre17-1mamba
- package created by autospec
